<template>
  <div>
    <span v-if="showSlot" @click="openDialog">
      <slot>
        <a-input
          ref="blurInput"
          read-only
          :value="value || defaultValue"
          :placeholder="$t('PLACESELECT')"
        />
      </slot>
      <a-icon
        v-show="showClear && (value || defaultValue)"
        type="close-circle"
        theme="filled"
        class="closeIcon"
        @click.stop="handleClear"
      />
    </span>
    <MomModalTable
      ref="MomModalTable"
      :modal-props="{
        title: $t('SELECT_MATERIAL'),
        visible: visible,
      }"
      :modal-listeners="{
        ok: handleConfirm,
        cancel: closeDialog,
      }"
      :table-props="{
        rowKey: rowKey,
        queryParam: queryForm,
        queryParamItem: queryFormItem,
        columns: tableColumns,
        dataSource: tableData,
        megaExtend: { rowAction: false },
        rowSelection,
        total,
        page,
        showUtilOperator: false,
        wholeExtraHeight: 82,
        customRow: (record) => {
          return {
            on: {
              click: () => handleRowClick(record),
            },
          };
        },
      }"
      :table-listeners="{
        beforeSearch: beforeSearch,
        search: searchPageData,
        'update:page': (current) => {
          page = current;
        },
      }"
    >
      <span slot="matUnit" slot-scope="text">
        {{ getAttrValue(unitList, text) }}
      </span>
    </MomModalTable>
  </div>
</template>
<script>
import { uniqBy } from "lodash";
import ApiConstant from "@/api/ApiConstant";
import MomModalTable from "@/components/MomModalTable";

export default {
  components: {
    MomModalTable,
  },
  props: {
    // 需要展示的key
    showKey: {
      type: String,
      default: "matCode",
    },
    // 回传的key
    rowKey: {
      type: String,
      default: "matCode",
    },
    deleteId: {
      type: String,
      default: "",
    },
    multiple: {
      type: Boolean,
      default: true,
    },
    // 是否显示slot
    showSlot: {
      type: Boolean,
      default: true,
    },
    // 是否显示清除按钮
    showClear: {
      type: Boolean,
      default: true,
    },
    defaultSelectedKeys: {
      type: Array,
      default() {
        return [];
      },
    },
    defaultSelectedRows: {
      type: Array,
      default() {
        return [];
      },
    },
  },
  data() {
    return {
      visible: false, // 弹框显示、隐藏
      tableData: [],
      unitList: [],
      // 查询的表单的配置项
      queryForm: {
        matCode: "", // 物料编码
        matName: "", // 物料名称
      },
      selectedKeys: [],
      selectedPageRows: {},
      value: undefined,
      total: 0,
      page: 1,
      initHeight: 0,
    };
  },
  computed: {
    defaultValue() {
      if (this.defaultSelectedKeys?.length) {
        return this.defaultSelectedKeys.join();
      }
      if (this.defaultSelectedRows?.length) {
        return this.defaultSelectedRows
          .map((item) => item[this.showKey])
          .join();
      }
      return undefined;
    },
    selectedRows() {
      let checked = Object.values(this.selectedPageRows).reduce(
        (res, item) => res.concat(item),
        []
      );

      const selectedRowsTmp = this.defaultSelectedRows.filter((item) =>
        this.selectedKeys.includes(item[this.rowKey])
      );
      if (this.multiple) {
        checked = uniqBy(checked.concat(selectedRowsTmp), this.rowKey);
      } else if (checked.length === 0) {
        checked.concat(selectedRowsTmp);
      }

      return checked;
    },
    rowSelection() {
      return {
        selectedRowKeys: this.selectedKeys,
        type: this.multiple ? "checkbox" : "radio",
        onChange: (selectedRowKeys, selectedRows) => {
          this.selectedKeys = selectedRowKeys;
          this.setSelectedPageRows();
        },
        getCheckboxProps: (record) => ({
          props: {
            disabled: record.disabled,
          },
        }),
      };
    },
    queryFormItem() {
      return this.$observable("queryFormItem", {
        matCode: {
          label: () => this.$t("MATERIAL_CODE"), // 物料编码
        },
        matName: {
          label: () => this.$t("MATERIAL_NAME"), // 物料名称
        },
      });
    },
    // 表格的配置项
    tableColumns() {
      return [
        {
          dataIndex: "matCode",
          title: () => this.$t("MATERIAL_CODE"),
          width: 200,
          ellipsis: true,
        },
        {
          dataIndex: "matName",
          title: () => this.$t("MATERIAL_NAME"),
          width: 160,
          ellipsis: true,
        },
        {
          dataIndex: "matTypeName",
          title: () => this.$t("MATERIAL_TYPE"),
          width: 160,
          ellipsis: true,
        },
        {
          dataIndex: "matUnit",
          title: () => this.$t("MATERIAL_UNIT"),
          width: 160,
          ellipsis: true,
        },
        {
          dataIndex: "updateBy", // 更新人员
          title: () => this.$t("UPDATE_BY"),
          width: 120,
        },
        {
          dataIndex: "updateTime", // 更新时间
          title: () => this.$t("UPDATE_TIME"),
          width: 168,
        },
      ];
    },
  },
  watch: {
    defaultValue: {
      handler() {
        this.value = undefined;
      },
      immediate: true,
    },
  },
  methods: {
    handleRowClick(record) {
      const index = this.selectedKeys.findIndex(
        (key) => key === record[this.rowKey]
      );
      if (index > -1) {
        this.selectedKeys.splice(index, 1);
      } else if (this.multiple) {
        this.selectedKeys.push(record[this.rowKey]);
      } else {
        this.selectedKeys = [record[this.rowKey]];
      }
      this.setSelectedPageRows();
    },
    // 打开弹框事件
    openDialog() {
      this.visible = true;
      const selectedKey = this.defaultSelectedRows
        .map((item) => item[this.rowKey])
        .concat(this.defaultSelectedKeys);
      this.selectedKeys = uniqBy([].concat(selectedKey));
      this.value = "";
    },
    // 获取数据字典
    beforeSearch() {
      return Promise.all([this.getDictByCode("DIC:CORE:MATERIAL_UNIT")]).then(
        ([unitRes]) => {
          this.unitList = unitRes?.data?.data || [];
        }
      );
    },
    /**
     * 获取table的数据
     */
    searchPageData(params) {
      this.$axios
        .get(`${ApiConstant.PREFIX_CORE}/api/mdm/material/search`, {
          params: {
            ...params,
            enableFlag: "Y",
          },
        })
        .then((res) => {
          if (res.data.data.records.length > 0) {
            this.tableData = res.data.data.records;
          } else {
            this.tableData = [];
          }
          // 数据需要禁用时使用
          // start
          this.defaultSelectedRows.forEach((itemA) => {
            const index = this.tableData.findIndex(
              (e) => e[this.rowKey] === itemA[this.rowKey]
            );
            if (index > -1) {
              this.$set(this.tableData[index], "disabled", itemA.disabled);
            } else {
              this.$set(this.tableData[index], "disabled", false);
            }
          });
          this.tableData.forEach((item, index) => {
            if (item.id === this.deleteId) {
              this.tableData.splice(index, 1);
            }
          });
          // end
          this.total = res.data.data.total;
          this.setSelectedPageRows();
        });
    },
    // 监听确认按钮事件
    handleConfirm() {
      // input显示的值
      this.value = this.selectedRows.map((item) => item[this.showKey]).join();
      // 回传 keys rows
      this.$emit("confirm", this.selectedKeys, this.selectedRows);
      this.visible = false;
    },
    // 关闭弹框
    closeDialog() {
      this.visible = false;
    },
    // 清空数据
    handleClear() {
      this.value = "";
      this.selectedKeys = [];
      this.$emit("confirm", [], []);
    },
    setSelectedPageRows() {
      if (!this.multiple) {
        Object.keys(this.selectedPageRows).forEach((e) => {
          if (e !== this.page) {
            delete this.selectedPageRows[e];
          }
        });
      }
      this.tableData.forEach((item) => {
        if (this.selectedKeys.includes(item[this.rowKey])) {
          if (this.selectedPageRows[this.page]?.length) {
            !this.selectedPageRows[this.page]
              .map((e) => e[this.rowKey])
              .includes(item[this.rowKey]) &&
              this.selectedPageRows[this.page].push(item);
          } else {
            this.$set(this.selectedPageRows, this.page, [item]);
          }
        } else if (this.selectedPageRows[this.page]?.length) {
          const index = this.selectedPageRows[this.page].findIndex(
            (e) => e[this.rowKey] === item[this.rowKey]
          );
          index > -1 && this.selectedPageRows[this.page].splice(index, 1);
        }
      });
    },
  },
};
</script>
<style scoped lang="less">
.closeIcon {
  position: absolute;
  right: 10px;
  top: 14px;
  font-size: 12px;
  cursor: pointer;
}
</style>
